#Create croc cost distance matrix

#Need cost surface raster as ASC and a CSV of locations in the same coord system

library(gdistance)
library(raster)

coords<-read.csv("crocloc_smallpop.csv")
coords2<-coords[,4:6]
cols=rainbow(19)
plot(coords2$Long, coords2$Lat,col=coords2$Name2,pch=20)

## Produce transition matrices, and correct because 8 directions
trCost <- transition(1/cost, mean, directions=8)
trCost <- geoCorrection(trCost, type="c")

require(raster)
require(gdistance)
require(PopGenReport)

res_raster<-raster("resistance100.asc")
locs<-read.csv("crocloc_smallpop.csv")
pC <- as.matrix(locs[c("Long","Lat")])

geoDist <- pointDistance(pC, longlat=TRUE)
geoDist <- as.dist(geoDist)

tr <- transition(1/res_raster, mean, directions=8)
trC <- geoCorrection(tr, "c", scl=TRUE)
trR <- geoCorrection(tr, "r", scl=TRUE)
cosDist <- costDistance(trC,pC)
colnames(cosDist)<-locs$Name2

library(reshape2)

df <- data.frame(melt(as.matrix(cosDist), varnames = c("row", "col")))



## Display results
plot(res_raster)
plot(SpatialPoints(pC), add=TRUE, pch=20, col="red")
text(pC[,1], pC[,2], 1:nrow(pC))
#Check a path
plot(shortestPath(trC, pC[16,], pC[17,], output="SpatialLines"), add=TRUE)

#Check another path
plot(shortestPath(trC, pC[4,], pC[19,], output="SpatialLines"), add=TRUE)


#Export cost distances and edit file
write.csv(df[,1:3],"costdist2.csv")

